var Player = {
	state : "", //live, archive, vod
	stopped : true,
	pause : false,
	url : "",
	plugin : null,
	mwPlugin : null,
	originalSource : null,
	livestream : false,
	buffering_complete : 0,
	total_time : 0,
	current_time : 0,
	time_control : null,
	step : 0.1,
}

Player.Init = function()
{
	this.plugin = byID("pluginPlayer");
   // this.plugin.SetInitialTimeOut(1);
	this.plugin.SetTotalBufferSize(1024);
	//this.plugin.SetInitialBuffer(1); // %age of total buffer
	//this.plugin.SetPendingBuffer(2);
    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.setTotalTime';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';   
	
	this.plugin.SetDisplayArea(0,0,960,540);
	
    var success = true;        
    
    if (!this.plugin)
    {
         success = false;
    }

	this.mwPlugin = byID("pluginObjectTVMW");
	if (!this.mwPlugin || !this.mwPlugin.GetSource) 
	{
		success = false;
	} 
	else 
	{
		this.originalSource = this.mwPlugin.GetSource();
		this.mwPlugin.SetMediaSource();
	}	
}

Player.Deinit = function()
{
	
	//if(this.mwPlugin != null)
		//this.mwPlugin.SetMediaSource(this.originalSource);
	
	if (this.plugin)
	{
		this.plugin.Stop();
	}
}

Player.Stop = function()
{
	
	if (!this.stopped)
	{
		if (this.state != "live")
		{
			this.stopped = true;     
			this.plugin.Stop();
			switch (this.state)
			{
				case "vod":
					Main.ChangeScreen("vod");
					break;
				case "archive":
					Main.ChangeScreen("epg");
					break;		
			}
			Player.StopTimeControl();
			this.current_time = 0;
		}else{
			this.plugin.Stop();
		}
		this.state = "";
    }

}

Player.Play = function(state)
{
		
	Player.Stop();
	this.state = state;		
	this.stopped = false;
	this.current_time = 0;
	Main.ShowInfo("Stream loading...");
	
	try
	{
	Player.plugin.InitPlayer(Player.url);
	Player.plugin.StartPlayback();
	} catch(e){
		alert("start old player: "+e);
		Player.plugin.Play( Player.url );
	}		
}
//Zamenil ot Nitro
//Player.Play = function(state)
//{
//		
//	Player.Stop();
//	this.state = state;		
//	this.stopped = false;
//	this.current_time = 0;
//	setTimeout("Player.LoadUrl();", 100);
//	Main.ShowInfo("Stream loading...");
//}

Player.LoadUrl = function()
{
	this.plugin.Play( this.url );	
}

Player.Pause = function()
{
	if (!this.stopped && (this.state != "live"))
	{				
		this.pause = true;
		this.plugin.Pause();
		Main.ShowInfo("Pause");
		//clearInterval(this.time_control);
	}
	alert("pause");	
}

Player.Resume = function()
{
	if ( !this.stopped && this.pause)
	{				
		this.pause = false;
		this.plugin.Resume();
		Main.CloseInfo();
		//Player.StartTimeControl();
	}
}

Player.Forward = function()
{
	if (this.state != "live")
	{
		var t_step = Math.floor(this.total_time*this.step);
		if ( (this.current_time + t_step) < this.total_time ){
			this.plugin.JumpForward(t_step);
			this.current_time+= t_step;	
			Player.UpdateTimeBar();	
		}
	}
}

Player.Backward = function()
{
	if (this.state != "live")
	{
		var t_step = Math.floor(this.total_time*this.step);
		if ( this.current_time > t_step )
		{
			this.plugin.JumpBackward(t_step);
			this.current_time -= t_step;
			Player.UpdateTimeBar();
		}else{
			this.plugin.JumpBackward(this.current_time);
			this.current_time = 0;
			Player.UpdateTimeBar();		
		}
	}
}


Player.onBufferingStart = function()
{
	Main.ShowInfo("Start Buffering...");
	this.buffering_complete = 0;
	//Player.StopTimeControl();
}

Player.onBufferingProgress = function(percent)
{
    Main.ShowInfo("Buffering " + percent + "%");
	if (this.buffering_complete)
		Main.CloseInfo();
}

Player.onBufferingComplete = function()
{
    alert("onBufferingComplete");
	Main.CloseInfo();
	this.buffering_complete = 1;	
	if (this.state != "live")
	{
		//this.total_time = this.plugin.GetDuration();
		//Player.StartTimeControl();
	}
}

Player.setCurTime = function(time)
{
   // Display.setTime(time);
   this.current_time = Math.floor(time/1000);
   Player.UpdateTimeBar();
   //alert("time" + time);
}

Player.setTotalTime = function()
{
    //Display.setTotalTime(this.plugin.GetDuration());
  this.plugin.SetDisplayArea(0,0,960,540);
	if (this.state != "live")
	{
		var temp = this.plugin.GetDuration();
		this.total_time = Math.ceil(temp/1000);
		switch (this.state)
		{
			case "archive":	 widgetAPI.putInnerHTML(byID("status-tv-time-f"), makeDurationTime(this.total_time)); break;
			case "vod":	 widgetAPI.putInnerHTML(byID("status-vod-time-f"), makeDurationTime(this.total_time)); break;
		}
		alert("total_time = " + this.total_time);
		
	}else{
		//widgetAPI.putInnerHTML(byID("status-tv-time-f"), "");
		this.total_time = 0;
	}
}

onServerError = function()
{
	Main.ShowInfo("Server Error!");
}

onNetworkDisconnected = function()
{
    Main.ShowInfo("Network Error!");
}

getBandwidth = function(bandwidth) { alert("getBandwidth " + bandwidth); }

onDecoderReady = function() { alert("onDecoderReady"); }

onRenderError = function() { alert("onRenderError"); }

stopPlayer = function()
{
    Player.stopVideo();
}

setTottalBuffer = function(buffer) { alert("setTottalBuffer " + buffer); }

Player.ShowStatusBar = function()
{
	
	Player.UpdateTimeBar();	
	var infoName = (this.state == "vod") ? "status-vod-bar" : "status-tv-bar";
	byID(infoName).style.display = (byID(infoName).style.display == "block") ? "none" : "block";	
}

Player.UpdateTimeBar = function()
{
	var temp = Math.ceil(this.current_time*100/this.total_time);
	var t_time = makeDurationTime(this.current_time);
	if (temp > 100) temp = 100;
	
	switch (this.state)
	{
		case "live"	: 
			byID("status-tv-progress").style.width = "0%"; 
			break;
		case "archive" : 
			byID("status-tv-progress").style.width = temp + "%"; 
			widgetAPI.putInnerHTML(byID("status-tv-time-s"), t_time);
			break;
		case "vod" : 
			byID("status-vod-progress").style.width = temp + "%"; 
			widgetAPI.putInnerHTML(byID("status-vod-time-s"), t_time);
			break;			
		
	}
	var timeBarName = (this.state == "live") ? "status-tv" : "status-vod-progress";
	
}

Player.StartTimeControl = function()
{
	this.time_control = setInterval("Player.current_time+=1; Player.UpdateTimeBar();", 1000);
}

Player.StopTimeControl = function()
{
	if (this.time_control)
		clearInterval(this.time_control);
}

Player.MainKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case tvKey.KEY_LEFT :	
			alert (this.plugin.GetDuration());  
			break;
		case tvKey.KEY_RIGHT :
			break;
		case tvKey.KEY_UP :			
			break;
		case tvKey.KEY_DOWN :			
			break;
		case tvKey.KEY_RED :
			EpgShort.Init();
			Main.ChangeScreen("epgshort");
			break;	
		case tvKey.KEY_YELLOW :	
			Main.ChangeScreen("vod");
			break;
		case tvKey.KEY_BLUE :
			if(this.black_line)
			{
			document.getElementById("black_line_top").style.display="none"; 
			this.black_line = false;
			}
			else
			{
			document.getElementById("black_line_top").style.display="block";
			this.black_line = true;
			}
			break;
        case tvKey.KEY_RETURN:			
			widgetAPI.blockNavigation(event);	
			/*
			switch (this.state)
			{
				case "live":
					//TV.updateChannelList();
					//Main.ChangeScreen("tv");
					break;
				case "archive":					
					Main.ChangeScreen("epg");
					break;		
				case "vod":					
					Main.ChangeScreen("vod");
					break;					
			}*/
			break;		
		case tvKey.KEY_ENTER :
			TV.updateChannelList();
			Main.ChangeScreen("tv");		
			break;
		case tvKey.KEY_PAUSE :			
			Player.Pause();
			break;		
		case tvKey.KEY_PLAY :			
			Player.Resume();
			break;			
		case tvKey.KEY_FF :			
			Player.Forward();
			break;		
		case tvKey.KEY_RW :			
			Player.Backward();
			break;		
		case tvKey.KEY_STOP :
			if (this.state != "live")
			Player.Stop();
			break;
		case tvKey.KEY_CH_UP:
			TV.PlayNextChannel();
			break;
		case tvKey.KEY_CH_DOWN:
			TV.PlayPrevChannel();
			break;				
		case tvKey.KEY_INFO:
			Player.ShowStatusBar();
			break;			
		default :
			break;
	}
	
}