var Epg = {
	list : [],
	page : 0,
	num : 0,	
	day : 0,
	on_page : 9,
	channel : {},
	maxlen : 0,
	days : ["Вс.","Пн.","Вт.","Ср.","Чт.","Пт.","Сб."],
}

Epg.DDMMYY = function(time)
{
    if(!time)
		return "";
	var mmToMonth = new Array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
	var Unixtime = new Date(time* 1000);
	var Day = Unixtime.getDate();
	if(Day<10)
		Day = '0' + Day;
	var Month = mmToMonth[Unixtime.getMonth()];
	var Year = Unixtime.getFullYear();
	Year = Year.toString();
	Year = Year.substring(2,4);
	return Day+Month+Year;
}

Epg.DDMM = function(time)
{
	var mmToMonth = new Array("01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12");
	var DayNum = time.getDay();
	var Day = time.getDate();
	if (Day < 10) Day = '0' + Day;
	var Month = mmToMonth[time.getMonth()];
	return (this.days[DayNum] + ' - ' + Day + "." + Month);
}

Epg.Init = function()
{	
	Epg.GetList();
	if (this.maxlen > 0)
	{
		Epg.showDayInfo();
		Epg.showChannelInfo();
		Epg.setStartNum();		
		Epg.updateList();	
	}
}

Epg.GetList = function()
{
	//var this.list = eval('(' + Main.SinGetRequest("epg.php?&cid=" + this.cid + "&day=" + Epg.DDMMYY()) +')');
	this.list = Main.SinGetRequest("epg.php?ignoreGmt=n&cid=" + this.channel.id + "&day=" + Epg.DDMMYY(Main.servertime + this.day*60*60*24));
	this.maxlen = this.list.epg.length;
}

Epg.showChannelInfo = function()
{
	byID("aepg_ch_img").src = Main.baseImgURL + this.channel.logo_big;
	widgetAPI.putInnerHTML(byID("aepg_ch_name"), this.channel.name);
}

Epg.showDayInfo = function()
{

	var cur_day = new Date((Main.servertime + this.day*60*60*24)* 1000);
	var next_day = new Date((Main.servertime + (this.day+1)*60*60*24)* 1000);
	var prev_day = new Date((Main.servertime + (this.day-1)*60*60*24)* 1000);
	
	
	widgetAPI.putInnerHTML(byID("cur_day"), Epg.DDMM(cur_day));
	widgetAPI.putInnerHTML(byID("next_day"), Epg.DDMM(next_day));
	widgetAPI.putInnerHTML(byID("prev_day"), Epg.DDMM(prev_day));
	if (this.day == 0) widgetAPI.putInnerHTML(byID("cur_day"), "Сегодня");
		
}

Epg.setStartNum = function()
{
	for (var i = 0; i < this.maxlen; i++)
		if (this.list.epg[i].ut_start > Main.servertime)
		{
			this.num = (i - 1) % this.on_page;
			this.page =  (i - 1 - this.num)/this.on_page;
			break;
		}
	if (this.num < 0) this.num = 0;
	alert("NUM : " + this.num);
	alert("PAGE : " + this.page);
	
}

Epg.setActive = function()
{
	var id = Epg.getEpgNum();
	var temp = (this.list.epg[id].progname.length > 60) ? this.list.epg[id].progname.substr(0,60) + '...' : this.list.epg[id].progname;
	byID("epg_progname_" +  this.num).className = "active";
	byID("epg_cur_prog").innerHTML = temp;
	
	if (this.list.epg[id].ut_start < Main.servertime)
	{
		widgetAPI.putInnerHTML(byID("epg_is_archive"), "Архив");		
		byID("epg_progress_bar").style.width = "100%";
	}else{
		widgetAPI.putInnerHTML(byID("epg_is_archive"), "");
		byID("epg_progress_bar").style.width = "0%";
	}
	widgetAPI.putInnerHTML(byID("epg_t_start"), this.list.epg[id].t_start);
	widgetAPI.putInnerHTML(byID("epg_t_end"), ((id+1) < this.maxlen) ? this.list.epg[id+1].t_start : "" );
	
}

Epg.setDeActive = function()
{
	byID("epg_progname_" +  this.num).className = "";
}

Epg.updateList = function()
{
	var num0 = this.on_page*this.page;
	for (var i = 0; i < this.on_page; i++)
	{
		byID("epg_progname_" +  i).className = "";
		if ( (num0 + i) < this.maxlen )
		{
			var temp = (this.list.epg[num0 + i].progname.length > 40) ?  this.list.epg[num0 + i].progname.substr(0,40) + '...' : this.list.epg[num0 + i].progname;

			widgetAPI.putInnerHTML(byID("epg_start_" + i), this.list.epg[num0 + i].t_start);
			widgetAPI.putInnerHTML(byID("epg_progname_" + i), temp);
			if ( (this.channel.have_archive == 1) && (this.list.epg[num0 + i].ut_start < Main.servertime) )
				byID("epg_archive_" + i).style.display = "block";
			else
				byID("epg_archive_" + i).style.display = "none";
		}else{
			widgetAPI.putInnerHTML(byID("epg_start_" + i), "");
			widgetAPI.putInnerHTML(byID("epg_progname_" + i), "");
			byID("epg_archive_" + i).style.display = "none";
		}
	}
	Epg.setActive();
}

Epg.getEpgNum = function(){ return (this.num + this.page*this.on_page);}

Epg.updateStatusBar = function()
{
	

}

Epg.KeyLeft = function()
{
	Epg.setDeActive();	
	/*
	if ( this.page > 0 )	
	{
		this.page--;
		Epg.updateList();	
	}else{
		this.day--;
		Epg.showDayInfo();
		Epg.GetList();		
		this.num = (this.list.epg.length - 1) % this.on_page;
		this.page = (this.list.epg.length - 1 - this.num)/this.on_page;		
		Epg.updateList();	
	}
	*/
	this.num = 0;
	this.page = 0;
	this.day--;

	Epg.showDayInfo();
	Epg.GetList();		
	Epg.updateList();	

	Epg.setActive();
}

Epg.KeyRight = function()
{
	var id = Epg.getEpgNum();
	
	Epg.setDeActive();

/*
	if ( (id+this.on_page)  < this.maxlen )
	{
		this.page++;
		Epg.updateList();	
	}else{
		this.day++;
		Epg.showDayInfo();
		this.num = 0;
		this.page = 0;
		Epg.GetList();		
		Epg.updateList();	
	}
*/

	this.day++;
	Epg.showDayInfo();
	this.num = 0;
	this.page = 0;
	Epg.GetList();		
	Epg.updateList();	
		
	Epg.setActive();
}

Epg.KeyDown = function()
{
	Epg.setDeActive();
	this.num++;
	/* для перехода на другой день
	if ( (this.num+this.on_page*this.page)  < this.maxlen )
	{
		if(this.num == this.on_page)
		{
			this.page++;
			this.num = 0;
			Epg.updateList();	
		}
	}else{
		this.day++;
		Epg.showDayInfo();
		this.num = 0;
		this.page = 0;
		Epg.GetList();		
		Epg.updateList();	
	}
	*/
	if ( (this.num+this.on_page*this.page)  < this.maxlen )
	{
		if(this.num == this.on_page)
		{
			this.page++;
			this.num = 0;
			Epg.updateList();	
		}
	}else{
		this.num = 0;
		this.page = 0;
		Epg.updateList();	
	}
	
	Epg.setActive();
}

Epg.KeyUp = function()
{
	Epg.setDeActive();
	this.num--;
	
	if ( this.num < 0 )
	{
		/* для перехода на другой день
		if (this.page == 0)
		{
			this.day--;
			Epg.showDayInfo();
			Epg.GetList();		
			this.num = (this.maxlen - 1) % this.on_page;
			this.page = (this.maxlen - 1 - this.num)/this.on_page;		
			Epg.updateList();
		}else{
			this.page--;
			this.num = this.on_page - 1;
			Epg.updateList();	
		}
		*/
		if (this.page == 0)
		{
			this.num = (this.maxlen - 1) % this.on_page;
			this.page = (this.maxlen - 1 - this.num)/this.on_page;	
			Epg.updateList();
		}else{
			this.page--;
			this.num = this.on_page - 1;
			Epg.updateList();	
		}		
	}	
	
	
	
	Epg.setActive();
}

Epg.KeyEnter = function()
{
	var el = this.list.epg[Epg.getEpgNum()];
	
	if (el.ut_start > Main.servertime)
	{
		TV.PlayChannel();
	}else{
		if (this.channel.have_archive == 1)
		{

			var url = Main.SinGetRequest("get_url.php?&cid=" + this.channel.id + '&gmt=' + el.ut_start);
			//Player.url = url.url.replace('http/ts://', 'http://');
			Player.url = url.url.split(' :')[0].replace('http/ts://', 'http://');
			Main.ChangeScreen("player");
			Player.Play("archive");
			widgetAPI.putInnerHTML(byID("status-tv-name"), el.progname);
			widgetAPI.putInnerHTML(byID("status-tv-desc"), this.channel.name);
			byID("status-tv-img").src = Main.baseImgURL + this.channel.logo_big;
			
			alert(el.progname);
		}
	}
}

Epg.MainKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case tvKey.KEY_LEFT :
			Epg.KeyLeft();
			break;
		case tvKey.KEY_RIGHT :
			Epg.KeyRight();
			break;
		case tvKey.KEY_UP :			
			Epg.KeyUp();
			break;
		case tvKey.KEY_DOWN :			
			Epg.KeyDown();
			break;
		case tvKey.KEY_ENTER :			
			Epg.KeyEnter();
			break;	
        case tvKey.KEY_RED:
			//Main.ChangeScreen("tv");			
		break;			
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			//Main.ChangeScreen(Main.backscreen);
			Main.ChangeScreen("epgshort");
		break;
	}
}