var Vod = {
	gid : 0,
	vid : 0,
	g_page : 0,
	g_on_page : 14,
	g_num : 0,
	v_page : 0,
	v_on_page : 18,
	v_on_row : 6,
	v_on_col : 3,
	v_num : 0,
	vod_list : {},
	genre_list : {},
	g_count : 0,
	v_count : 0,
	target : "genre",
}

Vod.Init = function()
{
	this.v_on_page = this.v_on_col*this.v_on_row;
	Vod.getGenreList();
	this.gid = this.genre_list[0].id;
	Vod.UpdateGenreList();
	Vod.SetActiveGenre();
}

Vod.getVodList = function()
{
	var temp = Main.SinGetRequest("vod_list.php?&genre=" + this.gid);
	try
	{
		this.vod_list = temp.rows;
		this.v_count = this.vod_list.length;		
		this.v_num = 0;
		this.v_page = 0;
	}catch(e){
		alert(e);
	}
}

Vod.UpdateVodList = function()
{	
	for (var i = 0; i < this.v_on_page; i++)
	{
		var k = i+this.v_page*this.v_on_page;
		try {
			if ( k < this.v_count)
			{
				byID("movie_name_" + i).innerHTML = this.vod_list[k].name;
				byID("movie_img_" + i).src = "http://megaimpuls.com:8102" + this.vod_list[k].poster;
			}else{
				byID("movie_name_" + i).innerHTML = "";
				byID("movie_img_" + i).src = "";
			}
		} catch(e) {
			alert(i + " " + e);
		}
	}	
	if (this.v_count > 0)
		Vod.SetActiveMovie();
}

Vod.getGenreList = function()
{
	var temp = Main.SinGetRequest("vod_genres.php?");
	try
	{
		this.genre_list = temp.genres;
		this.g_count = this.genre_list.length;		
	}catch(e){
		alert(e);
	}
}

Vod.UpdateGenreList = function()
{
	for (var i = 0; i < this.g_on_page; i++)
	{
		if ( (i+this.g_page*this.g_on_page) < this.g_count)
		{
			byID("genre_" + i).innerHTML = this.genre_list[i+this.g_page*this.g_on_page].name;
		}else{
			byID("genre_" + i).innerHTML = "";
		}
	}
	
}

Vod.SetActiveGenre = function()
{
	byID("genre_" + this.g_num).className = "active";
}

Vod.BlockActiveGenre = function()
{
	byID("genre_" + this.g_num).className = "block";
}

Vod.SetDeactiveGenre = function()
{
	byID("genre_" + this.g_num).className = "";
}


Vod.MainKeyHandler = function()
{
	switch (this.target)
	{
		case "genre":
			Vod.GenreKeyHandler();
			break;
		case "movie":
			Vod.MovieKeyHandler();
			break;
	}
}

Vod.GenreKeyRight = function()
{
	if (this.v_count > 0)
	{
		Vod.SetActiveMovie();
		this.target = "movie";
	}
}

Vod.GenreKeyDown = function()
{
	Vod.SetDeactiveGenre();
	if ( (this.g_num + this.g_page*this.g_on_page) < (this.g_count - 1))
	{
		if (this.g_num < (this.g_on_page - 1))
		{
			this.g_num++;
		}else{
			this.g_num = 0;
			this.g_page++;
			Vod.UpdateGenreList();
		}
	}
	Vod.SetActiveGenre();
}

Vod.GenreKeyUp = function()
{
	Vod.SetDeactiveGenre();
	if (this.g_num > 0)
	{
		this.g_num--;
	}else{
		if(this.g_page > 0)
		{
			this.g_page--;
			this.g_num = this.g_on_page - 1;
			Vod.UpdateGenreList();
		}
	}
	Vod.SetActiveGenre();
}

Vod.GenreKeyEnter = function()
{
	var i = this.g_num + this.g_on_page*this.g_page;
	
	widgetAPI.putInnerHTML(byID("empty-cat"), this.genre_list[i].name);
	byID("vod-empty-results").style.display = "none";
	
	this.gid = this.genre_list[i].id;
	Vod.getVodList();
	Vod.UpdateVodList();
	if (this.v_count > 0)	
	{
		Vod.BlockActiveGenre();
		this.target = "movie";
	}else{
		byID("vod-empty-results").style.display = "block";
	}
}

Vod.GenreKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case tvKey.KEY_DOWN:
			Vod.GenreKeyDown();
			break;
		case tvKey.KEY_UP:
			Vod.GenreKeyUp();
			break;
		case tvKey.KEY_ENTER:
			Vod.GenreKeyEnter();
			break;			
		case tvKey.KEY_RIGHT:
			Vod.GenreKeyRight();
			break;									
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Main.ChangeScreen("main");
		break;		
	}
}

/* MOVIE */

Vod.MovieKeyDown = function()
{
	Vod.SetDeactiveMovie();
	if ( (this.v_num + this.v_on_row) < this.v_count )
	{
		if ( (this.v_num + this.v_on_row) < this.v_on_row*this.v_on_col)
		{
			this.v_num += this.v_on_row;
		}else{
			
			this.v_num = this.v_num % this.v_on_row;
			this.v_page++;
			Vod.UpdateVodList();
		}
	}
	Vod.SetActiveMovie();
}

Vod.MovieKeyUp = function()
{
	Vod.SetDeactiveMovie();
	if ( this.v_num < this.v_on_row)
	{
		if (this.v_page > 0)
		{
			this.v_page--;
			this.v_num = this.v_on_row*(this.v_on_col - 1) + this.v_num;
			Vod.UpdateVodList();
		}
	}else{
		this.v_num -= this.v_on_row;
	}
	Vod.SetActiveMovie();
}

Vod.MovieKeyLeft = function()
{
	Vod.SetDeactiveMovie();
	if (this.v_num % this.v_on_row > 0)
	{
		this.v_num--;
		Vod.SetActiveMovie();
	}else{
		this.target = "genre";		
		Vod.SetActiveGenre();
	}
	
}

Vod.MovieKeyRight = function()
{
	Vod.SetDeactiveMovie();
	if ((this.v_num + 1) < this.v_count)
	{
		this.v_num++;
		
		if (this.v_num == (this.v_on_row*this.v_on_col))
		{
			this.v_num = 0;
			this.v_page++;
			Vod.UpdateVodList();
		}
	}
	Vod.SetActiveMovie();
}

Vod.MovieKeyEnter = function()
{
	
		Main.ChangeScreen("player");	
		Player.url = Vod.GetUrl();		
		Player.Play("vod");
						 
				
		widgetAPI.putInnerHTML(byID("status-vod-name"), byID("movie_name_" + this.v_num ).innerHTML);
		widgetAPI.putInnerHTML(byID("status-vod-desc"), "");
		byID("status-vod-img").src = byID("movie_img_" + this.v_num).src;		
		alert(byID("movie_img_" + this.v_num).src);
		alert(Player.state);
}

Vod.GetUrl = function()
{
	var temp = Main.SinGetRequest("vod_geturl.php?&fileid=" + this.vod_list[this.v_num + this.v_on_page*this.v_page].id);
	try {
		return temp.url;
	} catch(e) {
		alert(e);
		return "";
	}
}


Vod.SetActiveMovie = function()
{
	byID("movie_" + this.v_num).className = "active-movie";
}

Vod.SetDeactiveMovie = function()
{
	byID("movie_" + this.v_num).className = "";
}

Vod.MovieKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case tvKey.KEY_DOWN:
			Vod.MovieKeyDown();
			break;
		case tvKey.KEY_UP:
			Vod.MovieKeyUp();
			break;	
		case tvKey.KEY_LEFT:
			Vod.MovieKeyLeft();
			break;	
		case tvKey.KEY_RIGHT:
			Vod.MovieKeyRight();
			break;			
		case tvKey.KEY_ENTER:
			Vod.MovieKeyEnter();
			break;									
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			if (Player.state != "vod")
				Main.ChangeScreen("main");
			else
				Main.ChangeScreen("player");
		break;		
	}
}